<?php
session_start();

$page_title = "LEVEL 1 - Display FB Page Timeline Feed on Website - Live Demo";

date_default_timezone_set('America/Los_Angeles');
?>
<!DOCTYPE html>
<html lang="en">
<head>

    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title><?php echo $page_title; ?></title>

    <!-- Bootstrap CSS -->
	<link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" media="screen">

	<style>
	.profile-info{
		overflow:hidden;
	}

	.profile-photo{
		float:left;
		margin:0 .5em 0 0;
	}

	.profile-photo img{
		width:40px; height:40px;
	}

	.profile-name{
		float:left;
		width:85%;
	}

	.time-ago{
		color:#999;
	}

	.profile-message{
		margin:1em 0;
	}

	.post-link{
		text-decoration:none;
	}

	.post-content{
		background: #f6f7f9; border: 1px solid #d3dae8; overflow:hidden;
	}

	.post-content img{
		width:100%;
	}

	.post-status{
		margin:.5em; font-weight:bold;
	}

	.post-picture{
		width:25%; float:left;
	}

	.post-info{
		width:70%; float:left; margin:.5em;
	}

	.post-info-name{
		font-weight:bold;
	}

	.post-info-description{
		color:#999;
	}

	.like-icon {
		background-image: url('images/fb-sprite.png');
		background-repeat: no-repeat;
		background-size: auto;
		background-position: -146px -514px;
		height: 15px;
		width: 13px;
		display:block;
		float:left;
		margin: 2px 5px 0 0;
	}

	.comment-icon {
		background-image: url('images/fb-sprite.png');
		background-repeat: no-repeat;
		background-size: auto;
		background-position: -160px -514px;
		height: 15px;
		width: 13px;
		display:block;
		float:left;
		margin: 3px 5px 0 0;

	}
	</style>

</head>
<body>
<!-- pre-load loader images -->
<img src='images/ajax-loader-like-comment.gif' style='display:none;' />
<img src='images/ajax-loader.gif' style='display:none;' />

<div class="container">
	<div class='col-lg-12'>

	<?php
	$fb_page_id = !empty($_GET['fb_page_id']) ? $_GET['fb_page_id'] : "107786425949934";

	echo "<h1 class='page-header'>{$page_title}</h1>";

	// include_once "notes.php";

	// start getting fb feeds
	$profile_photo_src = "https://graph.facebook.com/{$fb_page_id}/picture?type=square";
	$access_token = "128623690525794|LbfgDAXN_KioIspqkMegG1-ysHA";
	$fields = "id,message,picture,link,name,description,type,icon,created_time,from,object_id,story,likes.limit(0).summary(true),comments.limit(0).summary(true)";
	$limit = 10;

	$json_link = "https://graph.facebook.com/{$fb_page_id}/feed?access_token={$access_token}&fields={$fields}&limit={$limit}";

	$json = file_get_contents($json_link);

	$obj = json_decode($json, true);
	$feed_item_count = count($obj['data']);

	$next_page = $obj['paging']['next'];

    for($x=0; $x<$feed_item_count; $x++){

    	echo "<div class='item_box'>";

    		// to get the post id
    		$id = isset($obj['data'][$x]['id']) ? $obj['data'][$x]['id'] : "";
    		$post_id_arr = explode('_', $id);
    		$post_id = $post_id_arr[1];

    		// user's custom message
    		$message=isset($obj['data'][$x]['message']) ? $obj['data'][$x]['message'] : "";
    		$message=htmlspecialchars_decode(str_replace("\n", "<br>", $message));

    		// picture from the link
    		$picture = isset($obj['data'][$x]['picture']) ? $obj['data'][$x]['picture'] : "";

    		// link posted
    		$link = isset($obj['data'][$x]['link']) ? $obj['data'][$x]['link'] : "";

    		// name or title of the link posted
    		$name = isset($obj['data'][$x]['name']) ? $obj['data'][$x]['name'] : "";

    		$description = isset($obj['data'][$x]['description']) ? $obj['data'][$x]['description'] : "";
    		$type = isset($obj['data'][$x]['type']) ? $obj['data'][$x]['type'] : "";

    		// story, used for example, page shared an event "[story] => OutCentral created an event."
    		$story = isset($obj['data'][$x]['story']) ? $obj['data'][$x]['story'] : "";

    		// when it was posted
    		$created_time = isset($obj['data'][$x]['created_time']) ? $obj['data'][$x]['created_time'] : "";
    		$converted_date_time = date( 'Y-m-d H:i:s', strtotime($created_time));
    		$ago_value = time_elapsed_string($converted_date_time);

    		// from
    		$page_name = isset($obj['data'][$x]['from']['name']) ? $obj['data'][$x]['from']['name'] : "";

    		// useful for photo
    		$object_id = isset($obj['data'][$x]['object_id']) ? $obj['data'][$x]['object_id'] : "";

    		echo "<div class='row'>";

    			// left side
    			echo "<div class='col-md-4'>";
    				echo "<div class='profile-info'>";

    					echo "<div class='profile-photo'>";
    						echo "<img src='{$profile_photo_src}' />";
    					echo "</div>"; // end 'profile-photo'

    					echo "<div class='profile-name'>";
    						echo "<div>";
    							echo "<a href='https://fb.com/{$fb_page_id}' target='_blank'>{$page_name}</a> ";
    							if(empty($story)){
    								echo "shared a ";
    								if($type=="status"){
    									$link="https://www.facebook.com/{$fb_page_id}/posts/{$post_id}";
    								}
    								echo "<a href='{$link}' target='_blank'>{$type}</a>";
    							}else{
    								if(strpos($story, "created an event") !== false) {
    									echo "created an <a href='{$link}' target='_blank'>event</a>";
    								}else{
    									echo "shared a <a href='{$link}' target='_blank'>post</a>";
    								}
    							}
    						echo "</div>";
    						echo "<div class='time-ago'>{$ago_value}</div>";
    					echo "</div>"; // end 'profile-name'

    				echo "</div>"; // end 'profile-info'

    				echo "<p class='profile-message'>";
    					echo "{$message}";
    				echo "</p>";
    			echo "</div>"; // end left side 'col-md-4'

    			// right side
    			echo "<div class='col-md-8'>";

    				echo "<a href='{$link}' target='_blank' class='post-link'>";

    					echo "<div class='post-content'>";

    						if($type=="status"){
    							echo "<div class='post-status'>";
    								echo "View on Facebook";
    							echo "</div>";
    						}

    						// created an event, etc.
    						else if($type=="link" && !empty($story)){
    							echo "<div class='post-status'>";
    								echo "View on Facebook";
    							echo "</div>";
    						}

    						else if($type=="photo"){
    							echo "<img src='https://graph.facebook.com/{$object_id}/picture' />";
    						}

    						else{
    							if($picture){
    								echo "<div class='post-picture'>";
    									echo "<img src='{$picture}' />";
    								echo "</div>";
    							}

    							echo "<div class='post-info'>";
    								echo "<div class='post-info-name'>{$name}</div>";
    								echo "<div class='post-info-description'>{$description}</div>";
    							echo "</div>";
    						}

    					echo "</div>"; // end 'post-content'
    				echo "</a>"; // end 'post-link'




    				// likes count
    				$likes_count=isset($obj['data'][$x]['likes']['summary']['total_count'])
    					? $obj['data'][$x]['likes']['summary']['total_count']
    					: 0;

    				// comments count
    				$comments_count=isset($obj['data'][$x]['comments']['summary']['total_count'])
    					? $obj['data'][$x]['comments']['summary']['total_count']
    					: 0;

    				echo "<div class='like-count-sum post-content' oid='{$object_id}' style='padding:.3em; margin:1em 0; cursor:pointer;'>";

    					echo "<div style='float:left; margin:0 .6em 0 0;'>";
    						echo "<span class='like-icon'></span> {$likes_count}";
    					echo "</div>";

    					echo "<div style='float:left;'>";
    						echo "<span class='comment-icon'></span> {$comments_count}";
    					echo "</div>";

    				echo "</div>"; // end 'like-count-sum'

    			echo "</div>"; // end right side 'col-md-8'

    		echo "</div>"; // end 'row'

    		echo "<hr />";
    	echo "</div>"; // end 'item_box'

    }
    ?>

	</div> <!-- /col-lg-12 -->
</div> <!-- /container -->

<!-- jQuery library -->
<script src="https://code.jquery.com/jquery-3.2.1.min.js"></script>

<!-- bootstrap JavaScript -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<!-- HTML5 Shiv and Respond.js IE8 support of HTML5 elements and media queries -->
<!-- WARNING: Respond.js doesn't work if you view the page via file:// -->
<!--[if lt IE 9]>
<script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
<script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
<![endif]-->

</body>
</html>

<?php
// to get 'time ago' text
function time_elapsed_string($datetime, $full = false) {

	$now = new DateTime;
	$ago = new DateTime($datetime);
	$diff = $now->diff($ago);

	$diff->w = floor($diff->d / 7);
	$diff->d -= $diff->w * 7;

	$string = array(
		'y' => 'year',
		'm' => 'month',
		'w' => 'week',
		'd' => 'day',
		'h' => 'hour',
		'i' => 'minute',
		's' => 'second',
	);
	foreach ($string as $k => &$v) {
		if ($diff->$k) {
			$v = $diff->$k . ' ' . $v . ($diff->$k > 1 ? 's' : '');
		} else {
			unset($string[$k]);
		}
	}

	if (!$full) $string = array_slice($string, 0, 1);
	return $string ? implode(', ', $string) . ' ago' : 'just now';
}
?>
